HDU 5379——Mahjong tree——————【搜索】

Mahjong tree

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 768    Accepted Submission(s): 241


Problem Description
Little sun is an artist. Today he is playing mahjong alone. He suddenly feels that the tree in the yard doesn't look good. So he wants to decorate the tree.(The tree has n vertexs, indexed from 1 to n.)
Thought for a long time, finally he decides to use the mahjong to decorate the tree.
His mahjong is strange because all of the mahjong tiles had a distinct index.(Little sun has only n mahjong tiles, and the mahjong tiles indexed from 1 to n.)
He put the mahjong tiles on the vertexs of the tree.
As is known to all, little sun is an artist. So he want to decorate the tree as beautiful as possible.
His decoration rules are as follows:

(1)Place exact one mahjong tile on each vertex.
(2)The mahjong tiles' index must be continues which are placed on the son vertexs of a vertex.
(3)The mahjong tiles' index must be continues which are placed on the vertexs of any subtrees.

Now he want to know that he can obtain how many different beautiful mahjong tree using these rules, because of the answer can be very large, you need output the answer modulo 1e9 + 7.
 
Input
The first line of the input is a single integer T, indicates the number of test cases. 
For each test case, the first line contains an integers n. (1 <= n <= 100000)
And the next n - 1 lines, each line contains two integers ui and vi, which describes an edge of the tree, and vertex 1 is the root of the tree.
 
Output
For each test case, output one line. The output format is "Case #x: ans"(without quotes), x is the case number, starting from 1.
 
Sample Input
2
9
2 1
3 1
4 3
5 3
6 2
7 4
8 7
9 3
8
2 1
3 1
4 3
5 1
6 4
7 5
8 4
 
Sample Output
Case #1: 32
Case #2: 16
 
 
题目大意:给出t表示t组测试数据。给出n,表示一棵树有n个顶点,下面有n-1条边的关系(没有明确给出谁到谁,错了好多次,以为u->v就是v为双亲u为儿子,然后建图错了)。让给树的各个结点编上号,从1->n。并且要求各个结点的所有儿子的编号是连续的,且子树的所有结点的编号也是连续的一段。问一共有多少种编号方法。
 
解题思路:题解中给出带有儿子的子节点的个数最多只能是两个。原因就是如果子节点带有儿子,那么就需要一段连续的数字,如果这段数字处在目前剩余的一段数字中间的话,那么必然不能让所有的子节点是连续的,所以如果有两个子节点是带有儿子的,那么这两个子节点应该分得目前所剩一段数字的两侧。如第二组样例:根的编号为1。则剩下数字2 3 4 5 6 7 8。现在子节点带有儿子的有两个,那么就应该让有三个子孙的结点3分得2,3,4,5。有一个子孙的结点5分得7,8。或者是让结点3分得5,6,7,8。让结点5分得2,3。可以看出,有两个结点带有儿子时,就只能让他们分在剩下数字的两端,如果超过两个结点带有儿子,就不能满足题意了。
 
 
#include<stdio.h>
#include<algorithm>
#include<string.h>
#include<vector>
using namespace std;
const int maxn=1e6+200;
vector<int>G[maxn];
const int MOD=1e9+7;
typedef long long INT;
#pragma comment(linker,"/STACK:1024000000,1024000000")  //加上扩栈,同时语言选C++,不然爆栈
INT fact(int x){
    if(x==0)
        return 1;
    INT ret=1;
    for(int i=2;i<=x;i++){
        ret=((ret%MOD)*(i%MOD))%MOD;
    }
    return ret;
}
INT dfs(int u,int fa){

    int lef=0,ulef=0;   //子节点是叶子的个数,子节点不是叶子的个数
    int v;
    INT tmp=0 , ret=1;  //ret保存方案数
    for(int i=0;i<G[u].size();i++){
        v=G[u][i];
        if(v==fa)
            continue;
        if(G[v].size()==1){
            lef++;
        }else{
            ulef++;
            tmp=dfs(v,u);
            if(tmp==-1)
                return -1;
            ret=((ret%MOD)*(tmp%MOD))%MOD;
        }
    }
    if(ulef<2){     //如果非叶子子节点个数小于2,叶子节点全排列,树根可以为最大值或最小值(之所以乘2)
        return ((2*ret%MOD)*(fact(lef)%MOD))%MOD;
    }else if(ulef==2){  //如果非叶子子节点等于2,只能让叶子节点全排列
        return ((ret%MOD)*(fact(lef)%MOD))%MOD;
    }else return -1;  //不合法
}
int main(){
    int t,n,u,v,cnt=0;
    scanf("%d",&t);
    while(t--){
        scanf("%d",&n);
        if(n==1){
            printf("Case #%d: 1
",++cnt);
            continue;
        }
        for(int i=1;i<n;i++){
            scanf("%d%d",&u,&v);
            G[v].push_back(u);
            G[u].push_back(v);
        }
        INT ans=dfs(1,-1);
        if(ans==-1)
            ans=0;
        printf("Case #%d: %lld
",++cnt,ans);
        for(int i=0;i<=n;i++)
            G[i].clear();
    }
    return 0;
}

  

 
 
 
原文地址:https://www.cnblogs.com/chengsheng/p/4723984.html